[build-system]
requires = ["setuptools>=64", "wheel", "setuptools_scm>=8"]
build-backend = "setuptools.build_meta"

[project]
name = "lhcsmqh"
authors = [{ name = "TE-MPE-CB", email = "lhc-signal-monitoring@cern.ch" }]
description = "SIGMON QH Analysis"
readme = "README.md"
requires-python = ">=3.11"
dependencies = [
    "lhcsmapi>=1.8.0rc12",
    "pandas>=1.5",
    "matplotlib",
    "jinja2",
]
dynamic = ["version"]

[project.optional-dependencies]
notebook = ["ipympl", "lhcsmnb", "nbconvert"]

[project.urls]
Repository = "https://gitlab.cern.ch/LHCData/lhc-sm-analysis/lhc-sm-qh"

[tool.setuptools_scm]

[tool.black]
line-length = 120
skip-magic-trailing-comma = true

[tool.ruff]
line-length = 120

[tool.ruff.lint]
select = [
    "A",
    "B",
    "E",
    "F",
    "N",
    "NPY",
    "W",
    "I",
    "UP",
    "SIM",
    "BLE",
    "PT",
    "RUF",
] # see https://docs.astral.sh/ruff/rules/

[tool.ruff.lint.per-file-ignores]
"*.ipynb" = ["E501"] # disable line-too-long in notebooks

[tool.mypy]
files = ["src"]
warn_unused_configs = true
warn_redundant_casts = true
warn_no_return = true
disallow_untyped_defs = true

[tool.pytest.ini_options]
addopts = ["--import-mode=importlib"]
pythonpath = "src"
